%global __brp_check_rpaths %{nil}
%global __requires_exclude ^libmpi
%global packname  GenAI
%global packver   0.2.0
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          0.2.0
Release:          1%{?dist}%{?buildtag}
Summary:          Generative Artificial Intelligence

License:          CC BY 4.0
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel
Requires:         R-core
BuildArch:        noarch
BuildRequires:    R-CRAN-magrittr 
BuildRequires:    R-CRAN-base64enc 
BuildRequires:    R-CRAN-httr 
BuildRequires:    R-CRAN-jsonlite 
BuildRequires:    R-tools 
BuildRequires:    R-CRAN-R6 
BuildRequires:    R-CRAN-listenv 
BuildRequires:    R-CRAN-magick 
BuildRequires:    R-CRAN-ggplotify 
Requires:         R-CRAN-magrittr 
Requires:         R-CRAN-base64enc 
Requires:         R-CRAN-httr 
Requires:         R-CRAN-jsonlite 
Requires:         R-tools 
Requires:         R-CRAN-R6 
Requires:         R-CRAN-listenv 
Requires:         R-CRAN-magick 
Requires:         R-CRAN-ggplotify 

%description
Utilizing Generative Artificial Intelligence models like 'GPT-4' and
'Gemini Pro' as coding and writing assistants for 'R' users. Through these
models, 'GenAI' offers a variety of functions, encompassing text
generation, code optimization, natural language processing, chat, and
image interpretation. The goal is to aid 'R' users in streamlining
laborious coding and language processing tasks.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
